/********************************************************************
 * kcam_sb.c       18-SEP-1991            Y.Takeuchi                *
 *                                                                  *
 * Slave Block Transfer                                             *
 * for SPARC cc device driver  K2917  K3922                         *
 *                                                                  *
 * 13-JUL-1992 Y.Takeuchi    modified for new-K2917 board           *
 ********************************************************************/

camac_b(cc, mode, naf, len, retlen)
struct cc_device *cc;
u_short mode, naf;
int len, *retlen;
{
    register int status;
    register u_short *ptr = cc->ptr_kdata;
    register struct K_REG *k = cc->CAMAC;

#ifdef DEBUG
    if (Debug_level >= 1)
        uprintf("camac_b  IN: mode:0x%x naf:0x%x len:%d retlen:%d\n",
	      mode, naf, len, *retlen);
#endif

    *retlen = 0;

    k->csr = RST;                             /* K2917 Reset */

    k->cma = CMA_INIT;                    /* Initialize memory pointer */
    k->cmr = mode | (cc->cur_crate << 8);
    k->cmr = naf;
    k->cmr = -(len & 0xFFFF);
    k->cmr = 0xFFFF;
    k->cmr = HALT;
    k->cma = CMA_INIT;                    /* Reset memory pointer */

    switch (naf & 0x0018) {
      case 0x0000:                        /* CAMAC read */
	k->csr &= ~WRITE;
	k->csr |= GO;                     /* Go! */
	if (mode & BIT16) {
	    while ((k->csr & (DONE | ERR)) == 0) {
		while ((k->csr & (RDY | DONE | ERR)) == 0)
		    ;
		if ((k->csr & RDY) != 0) {
		    *cc->ptr_kdata++ = k->dlr;
		    cc->len_kdata += 1;
		    *retlen += 1;
		}
	    }
	    copyout(ptr, cc->ptr_udata, cc->len_kdata * 2);
	}
	else {
	    while ((k->csr & (DONE | ERR)) == 0) {
		while ((k->csr & (RDY | DONE | ERR)) == 0)
		    ;
		if ((k->csr & RDY) != 0) {
		    *cc->ptr_kdata++ = k->dhr & 0x00FF;
		    *cc->ptr_kdata++ = k->dlr;
		    cc->len_kdata += 2;
		    *retlen += 2;
		}
	    }
	    copyout(ptr, cc->ptr_udata, cc->len_kdata * 4);
	}
	break;

      case 0x0010:                        /* CAMAC write */
	k->csr |= WRITE;
	k->csr |= GO;                     /* Go! */
	if (mode & BIT16) {
	    copyin(cc->ptr_udata, cc->ptr_kdata, len * 2);
	    while ((k->csr & (DONE | ERR)) == 0) {
		while ((k->csr & (RDY | DONE | ERR)) == 0)
		    ;
		if ((k->csr & RDY) != 0) {
		    k->dlr = *cc->ptr_kdata++;
		    *retlen += 1;
		}
	    }
	}
	else {
	    copyin(cc->ptr_udata, cc->ptr_kdata, len * 4);
	    while ((k->csr & (DONE | ERR)) == 0) {
		while ((k->csr & (RDY | DONE | ERR)) == 0)
		    ;
		if ((k->csr & RDY) != 0) {
		    k->dhr = *cc->ptr_kdata++;
		    k->dlr = *cc->ptr_kdata++;
		    *retlen += 2;
		}
	    }
	}
	break;

      default:                            /* ERROR */
	return -1;
	break;
    }
    cc->camac_qx = k->csr;
    status = k->csr >> 12;

#ifdef DEBUG
    if (Debug_level >= 1)
        uprintf("camac_b OUT: mode:0x%x naf:0x%x len:%d retlen:%d camac_qx:0x%x\n",
	      mode, naf, len, *retlen, cc->camac_qx);
#endif
    return status;
}
