/********************************************************************
 * kcam_ss.c       22-SEP-1991            Y.Takeuchi                *
 *                                                                  *
 * Slave Single Transfer                                            *
 * for SPARC cc device driver  K2917  K3922                         *
 *                                                                  *
 * 13-JUL-1992 Y.Takeuchi    modify for new-K2917 board             *
 *  5-MAR-1993 Y.Takeuchi    modify for unified UNIX camlib         *
 ********************************************************************/

camac_s(cc, mode, naf, dat)
struct cc_device *cc;
u_short mode, naf, *dat;
{
    register struct K_REG *k = cc->k;
    register int counter;

    cc->status = 0;

    k->csr = RST;                         /* K2917 Reset */
    k->cma = CMA_INIT;                    /* Initialize memory pointer */
    k->cmr = mode | (cc->cur_crate << 8); /* Write command list */
    k->cmr = naf;
    k->cmr = HALT;
    k->cma = CMA_INIT;                    /* Reset memory pointer */

    counter = 0;
    switch (naf & 0x0018) {
      case 0x0000:                        /* CAMAC read */
	k->csr &= ~WRITE;
	k->csr |= GO;                     /* Go! */
	while ((k->csr & (RDY | ERR)) == 0 && counter < CC_TIMEOUT_SINGLE)
	    counter++;
	if ((k->csr & RDY) != 0) {
	    if ((mode & BIT16) == 0) {
		*dat = k->dhr & 0x00FF;
		*(dat + 1) = k->dlr;
	    }
	    else
		*dat = k->dlr;
	}
	break;

      case 0x0010:                        /* CAMAC write */
	k->csr |= WRITE;
	k->csr |= GO;                     /* Go! */
	while ((k->csr & (RDY | ERR)) == 0 && counter < CC_TIMEOUT_SINGLE)
	    counter++;
	if ((k->csr & RDY) != 0) {
	    if ((mode & BIT16) == 0) {
		k->dhr = *dat;
		k->dlr = *(dat + 1);
	    }
	    else
		k->dlr = *dat;
	}
	break;

      default:                            /* NDT */
	k->csr |= GO;                     /* Go! */
	break;
    }

    while ((k->csr & (DONE | ERR)) == 0 && counter < CC_TIMEOUT_SINGLE)
        counter++;

    cc->camac_qx = k->csr;

    if (counter >= CC_TIMEOUT_SINGLE) {
        cc->status = CC_STA_SINGLE_TIMEOUT;
    }

    return cc->status;
}
