********************************************************************
* camh1.f        8-OCT-1991             Y.Takeuchi                 *
*                                                                  *
* CAMAC and HBOOK example program                                  *
* measure CAMAC single action speed                                *
* SPARC  SFVME-100  K2917  K3922                                   *
********************************************************************
      integer i, loop, nprint, icycle
      real    dummy, hmemor
      integer nn, nnt, nq, nx, ndat, ndat1
      integer naf, nafw, nafr, nafc, naft

      common /pawc/ hmemor(1000000)
c
c Parameters
c

c     Scaler
      nnt  = 6

c     Switch Register
      nn   = 11

      ndat = 4095
      write(0, 10)
      read(*,*) loop
      write(0, 20)
      read(*,*) nprint
c
c Initialize hbook
c
      call hlimit(1000000)
      call hbook1(11, 'CAMAC  T=0   (micro sec)$', 200, 0., 1000., 0.)
      call hbook1(12, 'CAMAC  Read  (micro sec)$', 200, 0., 1000., 0.)
      call hbook1(13, 'CAMAC  Write (micro sec)$', 200, 0., 1000., 0.)
      call hbook1(21, 'CAMACW T=0   (micro sec)$', 200, 0., 1000., 0.)
      call hbook1(22, 'CAMACW Read  (micro sec)$', 200, 0., 1000., 0.)
      call hbook1(23, 'CAMACW Write (micro sec)$', 200, 0., 1000., 0.)
c
c Initialize CAMAC
c
      nafr = NAF(nn,  1, 0)
      nafw = NAF(nn,  0, 16)
      nafc = NAF(nnt, 0, 9)
      naft = NAF(nnt, 0, 0)

      call CAMOPN()
      call CGENZ()
      call CGENC()
      call CREMI()
c
c Measurement
c
      do 100 i = 1, loop
         call CAMAC(nafc, ndat1, nq, nx)
         call CAMAC(naft, ndat1, nq, nx)
         call hfill(11, float(ndat1), dummy, 1.)
         call CAMAC(nafc, ndat1, nq, nx)
         call CAMAC(nafr, ndat, nq, nx)
         call CAMAC(naft, ndat1, nq, nx)
         call hfill(12, float(ndat1), dummy, 1.)
         call CAMAC(nafc, ndat1, nq, nx)
         call CAMAC(nafw, ndat, nq, nx)
         call CAMAC(naft, ndat1, nq, nx)
         call hfill(13, float(ndat1), dummy, 1.)
         call CAMACW(nafc, ndat1, nq, nx)
         call CAMACW(naft, ndat1, nq, nx)
         call hfill(21, float(ndat1), dummy, 1.)
         call CAMACW(nafc, ndat1, nq, nx)
         call CAMACW(nafr, ndat, nq, nx)
         call CAMACW(naft, ndat1, nq, nx)
         call hfill(22, float(ndat1), dummy, 1.)
         call CAMACW(nafc, ndat1, nq, nx)
         call CAMACW(nafw, ndat, nq, nx)
         call CAMACW(naft, ndat1, nq, nx)
         call hfill(23, float(ndat1), dummy, 1.)
 100  continue
c
c Write data to file
c
      open(unit=10,file='camh1.hdat',form='unformatted',recl=4096,
     $     access='direct',status='unknown')
      call hrfile(10, 'camh1', 'N')
      call hrout(0, icycle, ' ')
      call hrend('camh1')
c
c Display
c
      if (nprint .eq. 1) then
         call histdo
      endif
      call hplint(1)
      print *, ' Push return'
      read(*,*)
      call hplopt('PTO ', 1)
      call hplopt('HARD', 1)
      call hplzon(1, 1, 0, ' ')
      call hplot(0, ' ', ' ', 0)
      call hplend
c
c End
c
      call CAMCLS()
      stop
 10   format(' ', 'Input loop  >', $)
 20   format(' ', 'Print? (1:yes 0:no) >', $)
      end
