/************************************************************************
 *	camt31.c       	  2-DEC1991		Y.Takeuchi (TIT)	*
 *									*
 *	CAMAC LAM Interrupt speed test					*
 *	CAMAC Scaler ch1: input 1MHz pulse				*
 *	CAMAC ADC							*
 *	camt3 [lam_loop_count [data_count]]				*
 ************************************************************************/
#include <stdio.h>
#include "camtest.h"
#include "camlib.h"

#define DEFLOP    10
#define DEFLOP1    1
#define MAXLOP    100
#define DEFNAME   "camt31.obj"
#define MAXLIST   2000
#define MAXDATA   100000
#define LAMTOUT   2      /* 2sec */

main(argc, argv)
int argc;
char *argv[];
{
    int loop, i, mask, nafclrlam, nafct, nafrt, q, x, dat0, dat1, dumy;
    int lenlis, data[MAXDATA], nafr, nafc, loop1, j;
    struct cc_iosb iosb;
    char filename[33];
    unsigned short list[MAXLIST];

/* Read options */
    loop = (argc > 1) ? atoi(argv[1]) : DEFLOP;
    loop1 = (argc > 2) ? atoi(argv[2]) : DEFLOP1;

/* Initialize valiable */
    mask = 1 << (CAMAC_ADC - 1);
    nafct = NAF(CAMAC_SCALER, 1, 9);
    nafrt = NAF(CAMAC_SCALER, 1, 0);
    nafc = NAF(CAMAC_SCALER, 2, 9);
    nafr = NAF(CAMAC_SCALER, 2, 0);
    nafclrlam = NAF(CAMAC_ADC, 0, 10);

/* Open and Initialize CAMAC */
    if (CAMOPN()) {
      perror("CAMOPN");
      exit(1);
  }
    CSETCR(0);
    CGENC();
    CGENZ();
    CREMI();

/**** Measurement ****/
/* time=0 */
/*
    printf("%d\n", loop);
    for (i = 0; i < loop; i++) {
	CAMAC(nafct, &dumy, &q, &x);
	CAMAC(nafrt, &dat0, &q, &x);
	CAMAC(nafrt, &dat1, &q, &x);
	printf("%d\n", dat1 - dat0);
    }
*/

/* Call cc-driver */
    CELAM(mask);
    CAMAC(nafct, &dumy, &q, &x);
    CAMAC(nafrt, &data[0], &q, &x);
    for (i = 1; i <= loop; i++) {
	CWLAM(LAMTOUT);
	for (j = 0; j < loop1; j++)
	  CAMAC(nafrt, &dumy, &q, &x);
	CAMAC(nafclrlam, &dumy, &q, &x);
    }
    CAMAC(nafrt, &data[loop+1], &q, &x);
    CDLAM();

/* Printout */
/*
    printf("%d\n", loop);
    for (i = 0; i < loop + 1; i++)
      printf("%d\n", data[i+1] - data[i]);
*/
    printf("loop=%d  time = %d\n", loop, data[loop+1] - data[0]);

/* End */
    CAM_Close();
}
